package Tetris;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.JPanel;
import javax.swing.Timer;

//Ewen Kerbs,Zhe Wang-Holkenbrink
public class Board extends JPanel implements KeyListener
{
  private  static int FPS =60;
  private  static int delay =FPS/1000;

  public static final int BOARD_WIDTH=10;
  public static final int BOARD_HEIGHT=20;
  public static final int BLOCK_SIZE=30;

  private Timer loop;
  private Color[][] board = new Color[BOARD_WIDTH][BOARD_HEIGHT];
  private Color[] [] shape ={
          {Color.YELLOW,Color.YELLOW,Color.YELLOW},
          {null,Color.YELLOW,null}
  };
  private int x=4,y=0;
  private int normal =650;
  private int fast = 50;
  private long beginTime;
  private int delayTime = normal;

  public Board() {
    loop = new Timer(delay, new ActionListener() {
      int n = 0;

      @Override
      public void actionPerformed(ActionEvent e) {
        if(System.currentTimeMillis() -beginTime > delayTime){
          y++;
          beginTime=System.currentTimeMillis();
        }

        repaint();
        //System.out.println(n++);
      }
    });
    loop.start();
  }

  @Override
  protected void paintComponent(Graphics g) {
    super.paintComponent(g);
    g.fillRect(0, 0, getWidth(), getHeight());
    g.setColor(Color.lightGray);

    //shape mit 2-Forschleife
    for(int row=0;row< shape.length;row++){
      for(int col = 0;col< shape[0].length;col++){
          if(shape[row][col] !=null){
            g.setColor(shape[row][col]);
            //
            g.fillRect(col*BLOCK_SIZE+x*BLOCK_SIZE,row*BLOCK_SIZE+y*BLOCK_SIZE,BLOCK_SIZE,BLOCK_SIZE);
          }
      }

    }

    for (int row = 0; row < BOARD_HEIGHT+1; row++) {
      g.drawLine(0, BLOCK_SIZE * row, BLOCK_SIZE * BOARD_WIDTH, BLOCK_SIZE * row);
    }
    for (int col = 0; col < BOARD_WIDTH+1; col++) {
      g.drawLine(col * BLOCK_SIZE, 0, col * BLOCK_SIZE, BLOCK_SIZE * BOARD_HEIGHT);
    }

  }

  @Override
  public void keyTyped(KeyEvent e) {

  }

  @Override
  public void keyPressed(KeyEvent e) {
  if(e.getKeyChar() == KeyEvent.VK_SPACE){
    delayTime=fast;
  }
  }

  @Override
  public void keyReleased(KeyEvent e) {
    if(e.getKeyChar() == KeyEvent.VK_SPACE){
      delayTime=normal;
    }
  }
}
